/** 
  GUIDGen.cpp : Defines the entry point for the console application.

  Michael Presutti 

  Created: - 2000-05-16

  Updated: - 2002-01-22


  **/

#include "stdafx.h"
#include <windows.h>
#include <rpcdce.h>
#include <iostream.h>
#include <string.h>

BOOL UpdateIPR(LPCSTR lpISPath,LPCSTR lpGUID);
void ShowHelp(void);

int main(int argc, char* argv[])
{

	UUID uid;
	//RPC_STATUS rpcs;
	//RPC_ENTRY rpce;
	INT nd;
	INT rpce;

	if(argv[1]!=NULL)
		if(stricmp(argv[1],"/?")==0)
		{
			ShowHelp();
			return 0;
		}
	rpce=UuidCreate(&uid);

	switch(rpce)
	{
	case RPC_S_OK:
			nd=1;
			break;
	case RPC_S_UUID_LOCAL_ONLY:
		nd=2;
		break;
	case RPC_S_UUID_NO_ADDRESS:
		nd=3;
		break;
	}

	TCHAR szUid[MAX_PATH];
	unsigned char ** ppszUid=0;

	ppszUid = (unsigned char **)&szUid;
	UuidToString(&uid,ppszUid);

	if(argc>1)
	{
		if(UpdateIPR((LPCSTR)argv[1],(LPCSTR)*ppszUid))
		{
			RpcStringFree(ppszUid);
			return 0;
		}
	}
	cout << *ppszUid <<endl;

	RpcStringFree(ppszUid);
	return 0;
}



BOOL UpdateIPR(LPCSTR lpISPath,LPCSTR lpGUID)
{
/*	BOOL WritePrivateProfileString(
  LPCTSTR lpAppName,  // section name
  LPCTSTR lpKeyName,  // key name
  LPCTSTR lpString,   // string to add
  LPCTSTR lpFileName  // initialization file

  */
	TCHAR szTestBuf[MAX_PATH];

	if(GetPrivateProfileString(
		TEXT("DATA"),
		TEXT("INSTALLATIONGUID"),
		NULL,
		szTestBuf,
		MAX_PATH,
		lpISPath
		))
	{

		if(
			WritePrivateProfileString(
			TEXT("DATA"),
			TEXT("INSTALLATIONGUID"),
			lpGUID,
			lpISPath))
			return TRUE;
	}

	if(GetPrivateProfileString(
		TEXT("Project:Properties:Product"),
		TEXT("GUID"),
		NULL,
		szTestBuf,
		MAX_PATH,
		lpISPath
		))
	{
		if(
			WritePrivateProfileString(
			TEXT("Project:Properties:Product"),
			TEXT("GUID"),
			lpGUID,
			lpISPath))
			return TRUE;
	}

	return FALSE;

}

void ShowHelp(void)
{
	TCHAR *szHelpEnu[]={"\n\nUsage ISGUIDg <complete path to InstallShield .ipr project file. Use quotes> \n",
						"examples:\n",
						"  C:\\isguidg\n",
						"Will output:\n",
						"  b4fb8bc0-9d0f-4b6e-a848-ee6fbfa9c229\n\n",
						"  C:\\isguidg \"C:\\My Installations\\Default Setup\\Default Setup.ipr\"\n",
						"Will update the GUID for that project."};

	TCHAR *szHelpIta[]={"\n\nUso ISGUIDg < percorso completo all' archivio di progetto del ipr di InstallShield. Usare le virgolette > \n",
						"esempi:\n",
						"  C:\\isguidg\n",
						"Produrr:\n",
						"  b4fb8bc0-9d0f-4b6e-a848-ee6fbfa9c229\n\n",
						"  C:\\isguidg \"C:\\My Installations\\Default Setup\\Default Setup.ipr\"\n",
						"Aggiorner il GUID per quel progetto."};


	TCHAR *szHelpDeu[]={"\n\nVerbrauch ISGUIDg < kompletter Pfad zur InstallShield-ipr-Projektdatei. Verwenden Sie Anfhrungsstriche > \n",
						"Beispiele:\n",
						"  C:\\isguidg\n",
						"Gibt aus:\n",
						"  b4fb8bc0-9d0f-4b6e-a848-ee6fbfa9c229\n\n",
						"  C:\\isguidg \"C:\\My Installations\\Default Setup\\Default Setup.ipr\"\n",
						"Aktualisiert das GUID fr dieses Projekt."};


	TCHAR *szHelpEsp[]={"\n\nUso ISGUIDg < camino completo al fichero de proyecto del ipr de InstallShield. Utilice las cotizaciones >  \n",
						"ejemplos:\n",
						"  C:\\isguidg\n",
						"Har salir:\n",
						"  b4fb8bc0-9d0f-4b6e-a848-ee6fbfa9c229\n\n",
						"  C:\\isguidg \"C:\\My Installations\\Default Setup\\Default Setup.ipr\"\n",
						"Pondr al da el GUID para ese proyecto."};
	
	TCHAR *szHelpFra[]={"\n\nUtilisation ISGUIDg < voie d'accs complte au fichier-projet d'ipr d'InstallShield. Utilisez les guillemet >\n",
						"exemples:\n",
						"  C:\\isguidg\n",
						"Sortira:\n",
						"  b4fb8bc0-9d0f-4b6e-a848-ee6fbfa9c229\n\n",
						"  C:\\isguidg \"C:\\My Installations\\Default Setup\\Default Setup.ipr\"\n",
						"Mettra  jour le GUID pour ce projet."};

	LANGID lID,lIDpri, lIDscnd;

	lID = GetUserDefaultLangID();

	lIDpri = PRIMARYLANGID(lID);
	lIDscnd = SUBLANGID(lID);
	INT i=0;

	switch(lIDpri)
	{

	case LANG_ENGLISH:
			while (i<=6){cout<< szHelpEnu[i] <<endl;	i++;}
			break;

	case LANG_ITALIAN:
			while (i<=6){cout<< szHelpIta[i] <<endl;	i++;}
			break;

	case LANG_GERMAN:
			while (i<=6){cout<< szHelpDeu[i] <<endl;	i++;}
			break;

	case LANG_SPANISH:
			while (i<=6){cout<< szHelpEsp[i] <<endl;	i++;}
			break;

	case LANG_FRENCH:
			while (i<=6){cout<< szHelpFra[i] <<endl;	i++;}
			break;


	default:
			while (i<=6){cout<< szHelpEnu[i] <<endl;	i++;}
			break;
	}



	
}